package io.hmit.modules.competition.controller;

import io.hmit.common.annotation.LogOperation;
import io.hmit.common.constant.Constant;
import io.hmit.common.page.PageData;
import io.hmit.common.utils.ConvertUtils;
import io.hmit.common.utils.ExcelUtils;
import io.hmit.common.utils.Result;
import io.hmit.common.validator.AssertUtils;
import io.hmit.common.validator.ValidatorUtils;
import io.hmit.common.validator.group.AddGroup;
import io.hmit.common.validator.group.DefaultGroup;
import io.hmit.common.validator.group.UpdateGroup;
import io.hmit.modules.competition.dto.WlUploadInfoDTO;
import io.hmit.modules.competition.excel.WlUploadInfoExcel;
import io.hmit.modules.competition.service.WlUploadInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;


/**
 * 比赛人员信息
 *
 * @author zsh 408538940@qq.com
 * @since 1.0.0 2020-07-16
 */
@RestController
@RequestMapping("competition/wluploadinfo")
@Api(tags="比赛人员信息")
public class WlUploadInfoController {
    @Autowired
    private WlUploadInfoService wlUploadInfoService;

    @GetMapping("page")
    @ApiOperation("分页")
    @ApiImplicitParams({
        @ApiImplicitParam(name = Constant.PAGE, value = "当前页码，从1开始", paramType = "query", required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.LIMIT, value = "每页显示记录数", paramType = "query",required = true, dataType="int") ,
        @ApiImplicitParam(name = Constant.ORDER_FIELD, value = "排序字段", paramType = "query", dataType="String") ,
        @ApiImplicitParam(name = Constant.ORDER, value = "排序方式，可选值(asc、desc)", paramType = "query", dataType="String"),
    })
//    @RequiresPermissions("competition:wluploadinfo:page")
    public Result<PageData<WlUploadInfoDTO>> page(@ApiIgnore @RequestParam Map<String, Object> params){
        PageData<WlUploadInfoDTO> page = wlUploadInfoService.page(params);

        return new Result<PageData<WlUploadInfoDTO>>().ok(page);
    }

    @GetMapping("{id}")
    @ApiOperation("信息")
    @RequiresPermissions("competition:wluploadinfo:info")
    public Result<WlUploadInfoDTO> get(@PathVariable("id") Long id){
        WlUploadInfoDTO data = wlUploadInfoService.get(id);

        return new Result<WlUploadInfoDTO>().ok(data);
    }

/*
    @GetMapping("{name}")
    @ApiOperation("信息")
    //@RequiresPermissions("competition:wluploadinfo:info")
    public Result<List<WlUploadInfoDTO>> selectInfo(@PathVariable("name") String name){
        List<WlUploadInfoDTO> data = wlUploadInfoService.selectInfo(name);

        return new Result<List<WlUploadInfoDTO>>().ok(data);
    }
*/

    @PostMapping
    @ApiOperation("保存")
    @LogOperation("保存")
    //@RequiresPermissions("competition:wluploadinfo:save")
    public Result save(@RequestBody WlUploadInfoDTO dto){
        //校验数据
        ValidatorUtils.validateEntity(dto, AddGroup.class, DefaultGroup.class);
        boolean flag = wlUploadInfoService.isName(dto.getName());
        if(flag){
            wlUploadInfoService.save(dto);

            return new Result();
        }else {
            return new Result().error(500,"人员信息已存在!");
        }

    }

    @PutMapping
    @ApiOperation("修改")
    @LogOperation("修改")
    @RequiresPermissions("competition:wluploadinfo:update")
    public Result update(@RequestBody WlUploadInfoDTO dto){
        //校验数据
        ValidatorUtils.validateEntity(dto, UpdateGroup.class, DefaultGroup.class);

        wlUploadInfoService.update(dto);

        return new Result();
    }

    @DeleteMapping
    @ApiOperation("删除")
    @LogOperation("删除")
    @RequiresPermissions("competition:wluploadinfo:delete")
    public Result delete(@RequestBody Long[] ids){
        //校验数据
        AssertUtils.isArrayEmpty(ids, "id");

        wlUploadInfoService.delete(ids);

        return new Result();
    }

    @GetMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("competition:wluploadinfo:export")
    public void export(@ApiIgnore @RequestParam Map<String, Object> params, HttpServletResponse response) throws Exception {
        List<WlUploadInfoDTO> list = wlUploadInfoService.list(params);
        ExcelUtils.exportExcelToTarget(response, "比赛人员数据", list, WlUploadInfoExcel.class);
    }

/*
    @PostMapping("export")
    @ApiOperation("导出")
    @LogOperation("导出")
    @RequiresPermissions("competition:wluploadinfo:export")
    public void export(@RequestBody List<Long> checklist, HttpServletResponse response) throws Exception {
        List<WlUploadInfoDTO> list = new ArrayList<>();
        for(int i=0;i<checklist.size();i++){
            list.add(wlUploadInfoService.get(checklist.get(i)));
        }
        ExcelUtils.exportExcelToTarget(response, "比赛人员数据", list, WlUploadInfoExcel.class);
    }
*/

}
